## magma 0.2.2-1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Package: magma
 Title: Matrix Algebra on GPU and Multicore Architectures
-Version: 0.2.1-3
-Date: 2010-08-20
+Version: 0.2.2-1
+Date: 2010-08-27
 Author: Brian J Smith <brian-j-smith@uiowa.edu>
 Maintainer: Brian J Smith <brian-j-smith@uiowa.edu>
 Depends: R (>= 2.10.0), methods
@@ -16,6 +16,6 @@
 License: GPL (>= 3)
 URL: http://icl.cs.utk.edu/magma
 OS_type: unix
-Packaged: 2010-08-20 13:23:04 UTC; bjsmith
+Packaged: 2010-08-27 13:21:44 UTC; bjsmith
 Repository: CRAN
-Date/Publication: 2010-08-20 20:29:53
+Date/Publication: 2010-08-27 13:36:31
