=== debian/changelog ===
magma (2.5.4+ds-3) unstable; urgency=medium

  * Fix the broken symlinks due to missing Depends. (Closes: #985529)

 -- Mo Zhou <lumin@debian.org>  Thu, 25 Mar 2021 12:40:55 +0800

magma (2.5.4+ds-2) unstable; urgency=medium

  [ Andreas Beckmann ]
  * simplify cuda integration

  [ Mo Zhou ]
  * Add Turing and Ampere to the GPU_TARGET list.
  * Update my own mail address in d/control and d/copyright.

 -- Mo Zhou <lumin@debian.org>  Sun, 13 Dec 2020 17:35:25 +0800

magma (2.5.4+ds-1) unstable; urgency=medium

  * New upstream version 2.5.4
  * Remove unused symlinks from debian/ (Closes: #973802)
  * Rebase existing patches.
  * Patch makefiles to adjust GPU_TARGET to the supported ones.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Fri, 04 Dec 2020 11:00:29 +0800

magma (2.5.2+ds-1) experimental; urgency=medium

  * Initial release. (Closes: #941433)

 -- Mo Zhou <lumin@debian.org>  Thu, 23 Apr 2020 10:25:07 +0800
