=== debian/control ===
Source: magma
Section: contrib/math
Homepage: https://icl.cs.utk.edu/magma/
Priority: optional
Standards-Version: 4.4.0
Vcs-Git: https://salsa.debian.org/science-team/magma.git
Vcs-Browser: https://salsa.debian.org/science-team/magma
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Build-Depends: debhelper-compat (= 12),
               gfortran,
               libopenblas-dev,
               nvidia-cuda-toolkit-gcc,
Build-Depends-Indep: doxygen

Package: libmagma2
Section: contrib/libs
Architecture: any
Multi-Arch: no
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Matrix Algebra on GPU and Multicore Architectures (solib)
 The MAGMA project aims to develop a dense linear algebra library similar to
 LAPACK but for heterogeneous/hybrid architectures, starting with current
 "Multicore+GPU" systems.
 .
 The MAGMA research is based on the idea that, to address the complex challenges
 of the emerging hybrid environments, optimal software solutions will themselves
 have to hybridize, combining the strengths of different algorithms within a
 single framework. Building on this idea, we aim to design linear algebra
 algorithms and frameworks for hybrid manycore and GPU systems that can enable
 applications to fully exploit the power that each of the hybrid components
 offers.
 .
 This package contains the shared object libmagma.so.2

Package: libmagma-sparse2
Section: contrib/libs
Architecture: any
Multi-Arch: no
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Matrix Algebra on GPU and Multicore Architectures (solib, sparse)
 The MAGMA project aims to develop a dense linear algebra library similar to
 LAPACK but for heterogeneous/hybrid architectures, starting with current
 "Multicore+GPU" systems.
 .
 The MAGMA research is based on the idea that, to address the complex challenges
 of the emerging hybrid environments, optimal software solutions will themselves
 have to hybridize, combining the strengths of different algorithms within a
 single framework. Building on this idea, we aim to design linear algebra
 algorithms and frameworks for hybrid manycore and GPU systems that can enable
 applications to fully exploit the power that each of the hybrid components
 offers.
 .
 This package contains the shared object libmagma_sparse.so.2

Package: libmagma-dev
Section: contrib/libdevel
Architecture: any
Multi-Arch: no
Depends: ${misc:Depends}, ${shlibs:Depends},
 libmagma2 (= ${binary:Version}), libmagma-sparse2 (= ${binary:Version}),
Description: Matrix Algebra on GPU and Multicore Architectures (dev)
 The MAGMA project aims to develop a dense linear algebra library similar to
 LAPACK but for heterogeneous/hybrid architectures, starting with current
 "Multicore+GPU" systems.
 .
 The MAGMA research is based on the idea that, to address the complex challenges
 of the emerging hybrid environments, optimal software solutions will themselves
 have to hybridize, combining the strengths of different algorithms within a
 single framework. Building on this idea, we aim to design linear algebra
 algorithms and frameworks for hybrid manycore and GPU systems that can enable
 applications to fully exploit the power that each of the hybrid components
 offers.
 .
 This package contains the headers and the static libraries.

Package: libmagma-test
Architecture: any
Multi-Arch: no
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Matrix Algebra on GPU and Multicore Architectures (tests)
 The MAGMA project aims to develop a dense linear algebra library similar to
 LAPACK but for heterogeneous/hybrid architectures, starting with current
 "Multicore+GPU" systems.
 .
 The MAGMA research is based on the idea that, to address the complex challenges
 of the emerging hybrid environments, optimal software solutions will themselves
 have to hybridize, combining the strengths of different algorithms within a
 single framework. Building on this idea, we aim to design linear algebra
 algorithms and frameworks for hybrid manycore and GPU systems that can enable
 applications to fully exploit the power that each of the hybrid components
 offers.
 .
 This package contains the test executables.

Package: libmagma-doc
Section: contrib/doc
Architecture: all
Depends: ${misc:Depends}
Description: Matrix Algebra on GPU and Multicore Architectures (doc)
 The MAGMA project aims to develop a dense linear algebra library similar to
 LAPACK but for heterogeneous/hybrid architectures, starting with current
 "Multicore+GPU" systems.
 .
 The MAGMA research is based on the idea that, to address the complex challenges
 of the emerging hybrid environments, optimal software solutions will themselves
 have to hybridize, combining the strengths of different algorithms within a
 single framework. Building on this idea, we aim to design linear algebra
 algorithms and frameworks for hybrid manycore and GPU systems that can enable
 applications to fully exploit the power that each of the hybrid components
 offers.
 .
 This package contains the Doxygen HTML documentation.
