=== debian/watch ===
version=4
opts="repacksuffix=+ds, dversionmangle=s/\+ds\d*$//" \
https://icl.utk.edu/magma/software/index.html \
.*/magma-([\d.]*)\.tar\.gz debian uupdate
